﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Helpers;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Xml;

namespace EditingDemo
{
    public static class DataGridSerializationHelper
    {
        public static void SerializeColumns(this SfDataGrid sfDataGrid)
        {
            if (File.Exists("Columns.xml"))
                File.Delete("Columns.xml");
            XmlTextWriter writer = new XmlTextWriter("Columns.xml", System.Text.Encoding.UTF8);
            writer.WriteStartDocument(true);
            writer.Formatting = Formatting.Indented;
            writer.Indentation = 2;
            writer.WriteStartElement("Table");
            StringBuilder sb = new StringBuilder();
            foreach(var columns in sfDataGrid.Columns)
            {
                if (sb.ToString().Length > 0)
                {
                    sb.Append("|");
                }
                sb.Append(columns.MappingName);
            }
            CreateNode(sb.ToString(), writer);
            writer.WriteEndElement();
            writer.WriteEndDocument();
            writer.Close();

        }

        private static void CreateNode(string columnNmes, XmlTextWriter writer)
        {
            writer.WriteStartElement("Columns");
            writer.WriteStartElement("ColumnNames");
            writer.WriteString(columnNmes);
            writer.WriteEndElement();
            writer.WriteEndElement();
        }

        public static void DeserializeColumns(this SfDataGrid sfDataGrid)
        {
            List<string> SerializeColumns = GetColumns();
            if (SerializeColumns.Count == 0)
                return;
            int i = 0;
            sfDataGrid.Columns.Suspend();
            foreach (var columnNames in SerializeColumns)
            {
               int index = sfDataGrid.Columns.ToList().FindIndex(x => x.MappingName == columnNames);
               var columns = sfDataGrid.Columns[index];
               var columns1 = sfDataGrid.Columns[i];
               sfDataGrid.Columns[index] = columns1;
               sfDataGrid.Columns[i] = columns;
               i++;
            }

            sfDataGrid.Columns.Resume();
            sfDataGrid.RefreshColumns();
        }

        public static List<string> GetColumns()
        {
            List<string> columns = new List<string>();
            if (!File.Exists("Columns.xml"))
                return columns;
            XmlTextReader textReader = new XmlTextReader("Columns.xml");
            textReader.Read();
            // If the node has value  
            while (textReader.Read())
            {
                textReader.MoveToElement();
                if (textReader.NodeType == XmlNodeType.Text)
                {
                    columns.Add(textReader.Value);
                }
            }
            textReader.Close();
            columns= columns[0].Split('|').ToList();
            return columns;
        }
    }
}
